<template>
  <Row class="login-page">
    <div class="body-block" v-if="displayBodyBlock">
      <Spin size="large" fix></Spin>
    </div>
    <i-col :lg="{offset: 8, span: 8}" :md="{offset: 8, span: 8}" class="form-box">
      <div class="login-form">
        <div class="form-body" @keyup.enter="submitAction">
          <div class="form-title">
            <h1> Log In </h1>
          </div>
          <stock-form-item v-for="(field, index) in schemaFields(loginForm.schema)" :key="field"
                           v-model="loginForm.data[field]"
                           :options="loginForm.schema[field]"
                           :error="loginForm.error[field]"
                           :edit="true">
          </stock-form-item>
          <Row>
            <div class="literal-div-btn register-btn" @click="$redirectTo('register')">Register</div>
            <div class="literal-div-btn login-btn" @click="submitAction">Login</div>
          </Row>
        </div>
      </div>
    </i-col>
  </Row>
</template>

<script>
  import StockForm from "../components/StockForm";
  import { mixin, basicForm } from "../helpers/form";
  import StockFormItem from "../components/StockFormItem";
  import { mapActions } from "vuex";
  import { validators as api } from '../configs/request-validator/user';

  const actions = {
    async submitAction() {
      try {
        this.displayBodyBlock = true;
        const { data: { token } } = await this.$api(api.LoginRequest, this.loginForm.data);
        await this.setToken(token);
        this.$redirectTo('index');
      } catch (error) {
        this.displayBodyBlock = false;
        this.loginForm.error = this.$apiErrorHandler(error) || {};
      }
    },
  };

  export default {
    name: 'index',
    mixins: [ mixin ],
    components: {StockFormItem, StockForm},
    data() {
      return {
        displayBodyBlock: false,
        loginForm: undefined,
      };
    },
    methods: {
      ...mapActions(['setToken']),
      ...actions,
    },
    mounted() {
      this.$displayBodyBlock(false);
    },
    asyncData({ store, redirect }) {
      const hasToken = store.getters.hasToken;
      if (hasToken) {
        redirect('/');
      }

      const loginForm = {
        ...basicForm,
        schema: {
          email: { type: 'text', title: 'Email' },
          password: { type: 'password', title: 'Password' }
        },
        rules: api.LoginRequest.body,
        data: {},
      };

      return { loginForm };
    },
  }
</script>

<style lang="scss" scoped>
  @import "../assets/css/mixin";

  .login-page {
    height: 100vh;
    background-image: url("/images/background.jpg");
    background-size: cover;
    background-repeat: no-repeat;
    overflow-y: auto;
    .body-block {
      position: absolute;
      height: 100vh;
      width: 100vw;
      top: 0;
      left: 0;
      z-index: 2;
    }
    .ivu-spin-fix {
      background-color: rgba(4, 18, 42, 0.4);
    }
    .form-box {
      height: 100%;
      .login-form {
        position: relative;
        top: 20%;
        margin-bottom: 60px;
        .form-body {
          border-radius: 8px;
          padding: 20px;
          .form-title {
            color: rgb(30, 191, 240);
          }
        }
      }
    }
  }
</style>
